local mapMod = foundation.createMod();

mapMod:registerAssetId("maps/heightmap.png", "HEIGHT_MAP")
mapMod:registerAssetId("maps/material_mask.png", "MATERIAL_MASK")
mapMod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mapMod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mapMod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")
mapMod:registerAssetId("maps/tree_density_map1.png", "TREE_DENSITY_MAP1")
mapMod:registerAssetId("maps/tree_density_map2.png", "TREE_DENSITY_MAP2")
mapMod:registerAssetId("maps/tree_density_map3.png", "TREE_DENSITY_MAP3")

-- Register Custom Map
mapMod:register({
	DataType = "CUSTOM_MAP",
	Id = "SAARLAND_CLOEF_ID",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = 0,
	MaxHeight = 50,
	VillagePathList = {
		{
			Entrance = { 360, 0, 1013 },
			Exit = { 200, 0, 13 },
		},
		{
			Entrance = { 1010, 0, 1013 },
			Exit = { 1010, 0, 512 },
		},
		{
			Entrance = { 10, 0, 511 },
			Exit = { 1010, 0, 511 },
		}
	},
	SpawnList = {
		{
			-- creating Mineral Deposit 1
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 165 , 6 , 783 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 2
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 138 , 8 , 769 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 3
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 126 , 9 , 743 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 4
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 793 , 4 , 710 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 5
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 771 , 6 , 695 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 6
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 764 , 6 , 671 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 7
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 295 , 10 , 366 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 8
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 320 , 6 , 354 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 9
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 323 , 10 , 388 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 10
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 48 , 35 , 441 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 11
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 575 , 20 , 487 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 12
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 499 , 28 , 754 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 13
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 84 , 20 , 286 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 14
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 70 , 34 , 444 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 15
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 611 , 24 , 477 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 16
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 529 , 26 , 763 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 17
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 115 , 21 , 277 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 18
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 105 , 23 , 317 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 19
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 504 , 20 , 792 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 20
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 527 , 32 , 160 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 21
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 502 , 29 , 180 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 22
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 491 , 31 , 154 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 22
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 500 , 28 , 200 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 1
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 824 , 3 , 253 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 2
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 788 , 4 , 276 },
			Orientation = { 0.0, 90.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 3
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 789 , 4 , 240 },
			Orientation = { 0.0, -90.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 4
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 754 , 5 , 262 },
			Orientation = { 0.0, 45.0 , 0.0}
		}
	},
	DensitySpawnList = {
			{
			-- creating Tree Density Map1
			DensityMap = "TREE_DENSITY_MAP1",
			Density = 0.8,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_OAK" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.5607757568359375,0.61175537109375,0.2862701416015625,1 },
							Max = { 0.7843017578125,0.8431243896484375,0.556854248046875,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_SYCAMORE" },
						RandomWeight = 5.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.4,0.4,0.4,1 },
							Max = { 0.7,0.7,0.7,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_POPLAR" },
						RandomWeight = 1.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.79998779296875,0.5999908447265625,0.5999908447265625,1 },
							Max = { 0.941162109375,0.8901824951171875,0.8901824951171875,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_POPLAR" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.4,0.4,0.4,1 },
							Max = { 0.7,0.7,0.7,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_PINE" },
						RandomWeight = 1.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.4,0.4,0.4,1 },
							Max = { 0.7,0.7,0.7,1 }
					}
				}
			}
		},
			{
			-- creating Tree Density Map2
			DensityMap = "TREE_DENSITY_MAP2",
			Density = 0.8,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_SYCAMORE" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.4,0.4,0.4,1 },
							Max = { 0.7,0.7,0.7,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_PINE" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.4,0.4,0.4,1 },
							Max = { 0.7,0.7,0.7,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_PINE" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.0,0.3568572998046875,0.7176361083984375,1 },
							Max = { 0.3176422119140625,0.6588134765625,0.9999847412109375,1 }
					}
				}
			}
		},
			{
			-- creating Tree Density Map3
			DensityMap = "TREE_DENSITY_MAP3",
			Density = 0.8,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_PINE" },
						RandomWeight = 5.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.4,0.4,0.4,1 },
							Max = { 0.7,0.7,0.7,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_PINE" },
						RandomWeight = 5.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.4,0.4,0.2,1 },
							Max = { 0.8,0.8,0.4,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_PINE" },
						RandomWeight = 1.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.0,0.5,1.0,1 },
							Max = { 0.5,0.75,1.0,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_SYCAMORE" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.4,0.4,0.2,1 },
							Max = { 0.8,0.8,0.4,1 }
					}
				}
			}
		},
		{
			-- Create forest of berry bushes
			DensityMap = "BERRIES_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_BERRIES" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_ROCK" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = "FISH_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_FISH" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})
-- This map was created with the help of the UFME
